/**
 *	UI Layout Plugin: Slide-Offscreen Animation
 *
 *	Prevent panes from being 'hidden' so that an iframes/objects 
 *	does not reload/refresh when pane 'opens' again.
 *	This plug-in adds a new animation called "slideOffscreen".
 *	It is identical to the normal "slide" effect, but avoids hiding the element
 *
 *	Requires Layout 1.3.0.RC30.1 or later for Close offscreen
 *	Requires Layout 1.3.0.RC30.5 or later for Hide, initClosed & initHidden offscreen
 *
 *	Version:	1.0 - 2012-04-07
 *	Author:		Kevin Dalman (kevin.dalman@gmail.com)
 *	@preserve	jquery.layout.slideOffscreen-1.0.js
 */
(function(d){var b=d.layout;d.effects&&(b.defaults.panes.useOffscreenClose=!1,b.plugins&&(b.plugins.effects.slideOffscreen=!0),b.effects.slideOffscreen=d.extend(!0,{},b.effects.slide),d.effects.slideOffscreen=function(g){return this.queue(function(){var c=d.effects,i=g.options,a=d(this),e=a.data("layoutEdge"),j=a.data("parentLayout").state,e=j[e].size,f=this.style,k=c.setMode(a,i.mode||"show")=="show",c=i.direction||"left",l=c=="up"||c=="down"?"top":"left",m=c=="up"||c=="left",o=b.config.offscreenCSS||
{},h=b.config.offscreenReset,n={};n[l]=(k?m?"+=":"-=":m?"-=":"+=")+e;if(k){a.data("offscreenResetTop",{top:f.top,bottom:f.bottom});m?a.css(l,isNaN(e)?"-"+e:-e):c==="right"?a.css({left:j.container.offsetWidth,right:"auto"}):a.css({top:j.container.offsetHeight,bottom:"auto"});l==="top"&&a.css(a.data(h)||{})}else{a.data("offscreenResetTop",{top:f.top,bottom:f.bottom});a.data(h,{left:f.left,right:f.right})}a.show().animate(n,{queue:false,duration:g.duration,easing:i.easing,complete:function(){a.data("offscreenResetTop")&&
a.css(a.data("offscreenResetTop")).removeData("offscreenResetTop");k?a.css(a.data(h)||{}).removeData(h):a.css(o);g.callback&&g.callback.apply(this,arguments);a.dequeue()}})})})})(jQuery);